import "package:unittest/unittest.dart";
import "package:dson/dson.dart";

class MyClass {
  int i, j;
  MyNestedClass myNestedClass;
  int get sum => i + j;

  MyClass(this.i, this.j);
}

class MyNestedClass {
  String name;
  List<int> numbers;
  List<String> someStrings;
  List<MyNestedNestedClass> myNestedNestedClasses;
}

class MyNestedNestedClass {
  String nestedNestedName;
}


main() {

  MyClass myClass = new MyClass(3, 5)
    ..myNestedClass = (new MyNestedClass()
      ..name = "luis"
      ..numbers=[1,2]
      ..someStrings = ['a','b']
      ..myNestedNestedClasses = [
        new MyNestedNestedClass()..nestedNestedName = "nn1",
        new MyNestedNestedClass()..nestedNestedName = "nn2"
      ]
    );

  test('Object with list to Json test', () {
    expect(Writer.objectToJson(myClass), equals('{"i":3,"j":5,"myNestedClass":{"name":"luis","numbers":[1,2],"someStrings":["a","b"],"myNestedNestedClasses":[{"nestedNestedName":"nn1"},{"nestedNestedName":"nn2"}]},"sum":8}'));
  });

  List<MyClass> myClasses = [myClass, new MyClass(4,6)..myNestedClass = (new MyNestedClass()..name = 'Alberto'..numbers=[3,4])];
  test('List to Json test', () {
    expect(Writer.iterableToJson(myClasses), equals('[{"i":3,"j":5,"myNestedClass":{"name":"luis","numbers":[1,2],"someStrings":["a","b"],"myNestedNestedClasses":[{"nestedNestedName":"nn1"},{"nestedNestedName":"nn2"}]},"sum":8},{"i":4,"j":6,"myNestedClass":{"name":"Alberto","numbers":[3,4],"someStrings":null,"myNestedNestedClasses":null},"sum":10}]'));
  });
}